package se2030.parserdemo;

import se2030.parser.AbstractParserEventHandler;
import se2030.parser.Parser;
import se2030.studentroster.Student;
import se2030.trackbuilder.GPSTrackBuilder;
import se2030.studentroster.RosterBuilder;

import java.util.List;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/*
 * This app demonstrates how to use the Parser and GPSTrackBuilder to parse an xml file.
 */
public class ParserDemoApp /*implements IParserCompleteListener*/ {

	public static void main(String[] args) {

		String filename = "SampleXML.txt";
//		String filename = "Roster.txt"; 
//		String filename = "GPSTest5Center.txt"; // gpx file to be parsed (in this case assumed to be in cwd)
//		String filename = "InvalidGPX.txt"; 
//		String filename = "GPSTest5Center.txt"; 

		AbstractParserEventHandler handler = new ElementAnnouncer(); // This handler just reports XML elements as they are encountered by the Parser
//		AbstractParserEventHandler handler = new RosterBuilder();    // This handler creates a roster of Students (if the Parser is told to read a roster file)
//		AbstractParserEventHandler handler = new GPSTrackBuilder(); // This is the handler for creating GPS Tracks

		
		handler.enableLogging(true); // enable debug logging to System.out

		Parser parser = null;
		try {
			parser = new Parser( handler ); // create the Parser			
			parser.parse( filename );		// parse a file!
		} catch (SAXException e) {
			// something went wrong during parsing; print to the console since this is a console demo app.
			System.out.println("ParserDemoApp: Parser threw SAXException: " + e.getMessage() );
			System.out.println("The error occurred near line " + handler.getLine() + ", col "+ handler.getColumn());
		} catch (Exception e) {
			// something went wrong when initializing the Parser; print to the console since this is a console demo app.
			System.out.println("ParserDemoApp: Parser threw Exception: " + e.getMessage() );
		}
		
//		List<Student> roster = ((RosterBuilder)handler).getRoster();
//		System.out.println(((RosterBuilder)handler).getName());
//		for( Student s: roster ) 
//			System.out.println(s.toString());

	} 


}
